config/routes.rb
Rails.application.routes.draw do
  resources :collaborations
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  # resources :assignment_submissions
  resources :group_members ,only: [:create,:destroy]
  resources :groups do
    resources :assignments
  end

  scope '/groups' do
    get '/:id/assignments/WYSIWYG/index.css', to: redirect('/index.css')
    get '/:id/assignments/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')
    get '/:id/assignments/:id/WYSIWYG/index.css', to: redirect('/index.css')      # in case of editing
    get '/:id/assignments/:id/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')   # in case of editing
    get '/:group_id/assignments/:id/reopen', to: 'assignments#reopen', as: 'reopen_group_assignment'
    get '/:group_id/assignments/:id/start', to: 'assignments#start', as: 'assignment_start'
  end
  resources :stars , only: [:create, :destroy]


  devise_for :users, controllers: {registrations: 'users/registrations', :omniauth_callbacks => "users/omniauth_callbacks"}


  #Logix web pages resources
  root 'logix#index'
  get  '/gettingStarted', to:'logix#gettingStarted'
  get  '/examples', to:'logix#examples'
  get  '/features', to:'logix#features'
  get  '/about', to:'logix#about'
  get  '/privacy', to:'logix#privacy'
  get  '/tos', to:'logix#tos'
  get  '/search', to:'logix#search'
  get  '/teachers', to:'logix#teachers'
  get  '/contribute', to:'logix#contribute'

  #users
  scope '/users' do
    get '/', to: 'welcome#all_user_index', as: 'all_users'
    get '/:id/profile', to: 'users/logix#profile', as: 'profile'
    get '/:id/profile/edit', to: 'users/logix#edit', as: 'profile_edit'
    patch '/:id/update', to: 'users/logix#update', as: 'profile_update'
    get '/:id/groups', to: 'users/logix#groups', as: 'user_groups'
    get '/:id/', to: 'users/logix#index', as: 'user_projects'
    get '/:id/favourites', to: 'users/logix#favourites', as: 'user_favourites'
    get '/:id/projects/:id/WYSIWYG/index.css', to: redirect('/index.css')
    get '/:id/projects/:id/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')
  end


  #projects
  get 'projects/create_fork/:id', to: 'projects#create_fork',as: 'create_fork_project'
  get 'projects/change_stars/:id', to: 'projects#change_stars', as: 'change_stars'

  mount Commontator::Engine => '/commontator'

  #simulator
  scope '/simulator' do
    get '/:id', to: 'simulator#show', as: 'simulator'
    get '/edit/:id', to: 'simulator#edit', as: 'simulator_edit'
    post '/get_data', to: 'simulator#get_data'
    post '/update_data', to: 'simulator#update'
    post '/update_image', to: 'simulator#update_image'
    post '/create_data', to: 'simulator#create'
    get '/', to: 'simulator#new', as: 'simulator_new'
    get '/embed/:id', to: 'simulator#embed', as: 'simulator_embed'
  end
  # get 'simulator/embed_cross/:id', to: 'simulator#embed_cross', as: 'simulator_embed_cross'


  resources :users do
    resources :projects, only: [:show, :edit, :update, :new, :create, :destroy]
  end




  # get 'comments/create_reply/:id', to: 'comments#create_reply', as: 'reply_comment'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/group.rb
class Group < ApplicationRecord
  belongs_to :mentor, class_name: 'User'
  has_many :group_members, dependent: :destroy
  has_many :users, through: :group_members

  has_many :assignments , dependent: :destroy
  has_many :pending_invitations , dependent: :destroy

  after_commit :send_creation_mail, on: :create

  def send_creation_mail
      GroupMailer.new_group_email(self.mentor,self).deliver_later
  end
end

app/controllers/groups_controller.rb
class GroupsController < ApplicationController
  before_action :set_group, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!
  before_action :set_and_check_access, only: [:show, :edit, :update, :destroy]
  before_action :check_edit_access, only: [:edit,:update, :destroy]

  # GET /groups
  # GET /groups.json
  def index
    @groups = Group.all
  end

  # GET /groups/1
  # GET /groups/1.json
  def show
    @group_member = @group.group_members.new
    @group.assignments.each do |assignment|
      if assignment.status == 'reopening' and assignment.deadline < Time.now
        assignment.status = 'closed'
        assignment.save
      end
    end
  end

  # GET /groups/new
  def new
    @group = Group.new
  end

  # GET /groups/1/edit
  def edit
  end

  # POST /groups
  # POST /groups.json
  def create
    @group = current_user.groups_mentored.new(group_params)

    respond_to do |format|
      if @group.save
        format.html { redirect_to @group, notice: 'Group was successfully created.' }
        format.json { render :show, status: :created, location: @group }
      else
        format.html { render :new }
        format.json { render json: @group.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /groups/1
  # PATCH/PUT /groups/1.json
  def update
    respond_to do |format|
      if @group.update(group_params)
        format.html { redirect_to @group, notice: 'Group was successfully updated.' }
        format.json { render :show, status: :ok, location: @group }
      else
        format.html { render :edit }
        format.json { render json: @group.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /groups/1
  # DELETE /groups/1.json
  def destroy
    @group.destroy
    respond_to do |format|
      format.html { redirect_to user_groups_path(current_user), notice: 'Group was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_group
      @group = Group.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def group_params
      params.require(:group).permit(:name, :mentor_id)
    end

    def set_and_check_access

      @admin_access = ((@group.mentor_id==current_user.id) or current_user.admin)
      if (!@admin_access and GroupMember.find_by(user_id:current_user.id,group_id:@group.id).nil?)
        render plain: "Access restricted" and return
      end
    end

  def check_edit_access
    if (!@admin_access)
      render plain: "Access restricted" and return
    end
  end
end

app/helpers/groups_helper.rb
module GroupsHelper
end

app/views/groups/_form.html.erb
<%= form_with(model: group, local: true) do |form| %>
  <% if group.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(group.errors.count, "error") %> prohibited this group from being saved:</h2>

      <ul>
      <% group.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :group_name %>
  </div>


  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/groups/edit.html.erb
<div class="container">
  <div class="row feature">

    <div class="col">
      <h1>Editing Group</h1>

      <%= render 'form', group: @group %>

      <%= link_to 'Show', @group %> |
      <%= link_to 'Back', user_groups_path(current_user) %>

    </div>


  </div>
  <br />

  <br />



</div>

app/views/groups/new.html.erb
<div class="container">
  <div class="row feature">

    <div class="col">
      <h1>New Group</h1>

      <%= render 'form', group: @group %>

      <%= link_to 'Back', groups_path %>

    </div>


  </div>
  <br />

  <br />



</div>

app/views/groups/show.html.erb
<div class="container">
  <div class="row feature">

    <div class="col">

      <% if notice %>
        <p id="notice" class="alert alert-success"><%= notice %></p>
      <% end %>

      <p>
        <strong>Name:</strong>
        <%= @group.name %>
      </p>

      <p>
        <strong>Mentor:</strong>
        <%= @group.mentor.name %>
      </p>



      <h3>Group members</h3>
        <div style="max-height:400px;overflow:hidden;overflow-y:scroll" >
          <table class="table">
            <!--<thead>-->
            <!--<tr>-->
              <!--<th>Group members</th>-->
              <!--<th>Email IDs</th>-->
              <!--<th>Action</th>-->

            <!--</tr>-->
            <!--</thead>-->

            <tbody>

            <% @group.users.each do |user| %>
                <tr>
                  <td><%= link_to user.name, user %></td>
                  <td><%= user.email %></td>
                  <% if @admin_access %>
                      <td><%= link_to 'Remove', group_member_path(GroupMember.find_by(user_id:user.id,group_id:@group.id)), method: :delete, data: { confirm: 'Are you sure?' } %></td>
                  <% end %>
                </tr>
            <% end %>

            <tbody/>
          </table>

      </div>




      <div id="myModal" class="modal fade" role="dialog">
        <div class="modal-dialog">

          <!-- Modal content-->
          <div class="modal-content">
            <div class="modal-header">
              <h4 class="modal-title">Add members</h4>
              <button type="button" class="close" data-dismiss="modal">&times;</button>

            </div>
            <div class="modal-body">
              <p>Enter Email IDs separated by commas. If users are not registered, an email ID will be sent requesting them to sign up.</p>
              <%= form_with(model: @group_member, local: true) do |form| %>
                  <% if @group_member.errors.any? %>
                      <div id="error_explanation">
                        <h2><%= pluralize(group_member.errors.count, "error") %> prohibited this group_member from being saved:</h2>

                        <ul>
                          <% @group_member.errors.full_messages.each do |message| %>
                              <li><%= message %></li>
                          <% end %>
                        </ul>
                      </div>
                  <% end %>

                  <div class="field">
                    <%= form.hidden_field :group_id, id: :group_member_group_id %>
                  </div>

                  <div class="form-group">
                    <label for="Email Ids">Email IDs:</label>
                    <textarea class="form-control" rows="5" id="emails" name="group_member[emails]"></textarea>
                  </div>

                  <div class="actions modal-footer">
                    <%= form.submit "Add members", class: 'btn btn-secondary' %>
                  </div>
              <% end %>
            </div>
            <!--<div class="modal-footer">-->
              <!--<button type="button" class="btn btn-secondary" data-dismiss="modal">close</button>-->
            <!--</div>-->
          </div>

        </div>
      </div>

      <% if @admin_access %>
          <button type="button" class="btn btn-secondary btn-info" data-toggle="modal" data-target="#myModal">Add member</button>
            <%= link_to 'Add new assignment', new_group_assignment_path(@group), class: "btn btn-info" %>
          <br>
          <br>
      <%end%>


      <table class="table">
        <thead>
        <tr>
          <th>Assignment</th>
          <th>DeadLine</th>
          <th>Preview</th>
          <th>Actions</th>

        </tr>
        </thead>

        <tbody>
        <tbody>
        <% @group.assignments.each do |assignment| %>
            <tr>
              <td><%= assignment.name %></td>
              <td><div class="date"><%= assignment.deadline.strftime("%d %b,%Y %I:%M %p %Z") %></div>
                <% if(assignment.deadline > Time.now) %>
                <p> <strong>Time remaining: </strong><%=(( assignment.deadline.to_i - Time.now.to_i)/1.day)%> days,  <%=(( assignment.deadline.to_i- Time.now.to_i)/1.hour)%24%> hours, <%=(( assignment.deadline.to_i- Time.now.to_i)/1.minute)%60%> minutes</p>
                <% end %>
              </td>
              <td><%= link_to 'Show', group_assignment_path(@group,assignment) %></td>
              <td>
                <% if @admin_access %>
                  <% if assignment.status!="closed" %>
                    <%= link_to 'Edit', edit_group_assignment_path(@group,assignment) %>
                  <% else %>
                    <%= link_to 'Reopen', reopen_group_assignment_path(@group,assignment) %>
                  <% end %>
                  <%= link_to 'Destroy', group_assignment_path(@group,assignment), method: :delete, data: { confirm: 'Are you sure?' } %>
                <% else %>

                    <% project_assignment=Project.find_by(author_id:current_user.id,assignment_id:assignment.id) %>

                    <% if(assignment.deadline > Time.now) %>
                        <% if project_assignment.nil?%>
                            <%= link_to 'Start Working', assignment_start_path(@group,assignment) %>
                        <% else %>
                            <%= link_to 'View your work', user_project_path(current_user,project_assignment) %>
                        <% end %>
                    <% else %>
                        <% if project_assignment.nil?%>
                            Not submitted!
                        <% else %>
                            <%= link_to 'View your submission', user_project_path(current_user,project_assignment) %>
                        <% end %>
                    <% end %>

              <% end %>


              </td>

            </tr>
        <% end %>
        </tbody>
      </table>
      <% if @admin_access %>
      <%= link_to 'Edit', edit_group_path(@group) %> |
      <% end %>
      <%= link_to 'Back', user_groups_path(current_user) %>

    </div>


  </div>
  <br />

  <br />

  <script src="/js/time.js"></script>
  <script>
      $(document).ready(function() {

          $('.date').each(function(){
              this.innerHTML = formatDate(new Date(this.innerHTML), "dddd hh:mmTT zz, dd MMM yyyy")
          })
      })
  </script>

</div>